#!/usr/bin/env bash
# Use on linux and mac, build and run simple demo like ./RunDemo.sh annotation etc.

execdir=`pwd`

SYS_NAME=`uname`
if [ "$SYS_NAME" = "Darwin" ]; then
suffix_csproj="mac"
elif [ "$SYS_NAME" = "Linux" ]; then
suffix_csproj="linux"
else
suffix_csproj="linux"
fi

SYS_BIT=`getconf LONG_BIT`
bit_config=${SYS_BIT}
if [ -z $bit_config ]; then
bit_config="64"
fi

if [ -z $1 ]; then
echo "Please input parameter."
exit 1
fi

for i in $@; do
if [ "$i" == "dbg" ]; then
IS_USE_DEBUG=1
continue
elif [ "$i" == "all" ]; then
CSPROJ_BUILD_ALL=1
fi
done

if [ -z $IS_USE_DEBUG ]; then
build_config=rel
else
build_config=dbg
fi

if [ -z $CSPROJ_BUILD_ALL ]; then
dir_input_arrs=$@
else
dir_input_arrs=`ls`
fi

csproj_names=()
for i in ${dir_input_arrs[@]}; do
if [ -f $i/$i.csproj ]; then
csproj_names[${#csproj_names[@]}]=$i
fi
done

if [ ${#csproj_names[@]} == 0 ]; then
echo "Please input correct parameter."
exit 1
fi

echo "Os:" ${suffix_csproj}
echo "build_config:" ${build_config}
echo "csproj_names length:" ${#csproj_names[@]}
echo "csproj_names:" ${csproj_names[@]}

for i in ${csproj_names[@]}; do
dotnet clean $i/$i.csproj
done

for i in ${csproj_names[@]}; do
dotnet build $i/$i.csproj
done

cd "$execdir/bin"

for i in ${csproj_names[@]}; do
if [ "$SYS_NAME" = "Darwin" ]&&[ ${i} = "dwg2pdf" ]; then
  export LD_LIBRARY_PATH=$DWG_ENGINE_PATH:$LD_LIBRARY_PATH
fi
echo && echo $i:
dotnet $i.dll
done

